
public class M04Maze
{
	//----------------------------萔
	//Ε
	final int DIRECT_X_PLUS=0;
	final int DIRECT_X_MINUS=1;
	final int DIRECT_Z_PLUS=2;
	final int DIRECT_Z_MINUS=3;
	final int DIRECT_Y_PLUS=4;
	final int DIRECT_Y_MINUS=5;
	final int DIRECT_LIMIT=6;
	//Ε
	final int WAY_FRONT=0;
	final int WAY_BACK=1;
	final int WAY_RIGHT=2;
	final int WAY_LEFT=3;
	final int WAY_UP=4;
	final int WAY_DOWN=5;
	//
	final int AXIS_X=0;
	final int AXIS_Y=1;
	final int AXIS_Z=2;
	//̐Εֈړۂ̊e̕ω
	final int direct_axis[/*direct*/][/*axis*/]={{1,0,0},{-1,0,0},{0,0,1},{0,0,-1},{0,1,0},{0,-1,0}};
	//݌ĂΕ炻̑Ε̐Ε
	final int direction_way[/*direction*/][/*way*/]={
		{DIRECT_X_PLUS,DIRECT_X_MINUS,DIRECT_Z_PLUS,DIRECT_Z_MINUS,DIRECT_Y_MINUS,DIRECT_Y_PLUS},
		{DIRECT_X_MINUS,DIRECT_X_PLUS,DIRECT_Z_MINUS,DIRECT_Z_PLUS,DIRECT_Y_MINUS,DIRECT_Y_PLUS},
		{DIRECT_Z_PLUS,DIRECT_Z_MINUS,DIRECT_X_MINUS,DIRECT_X_PLUS,DIRECT_Y_MINUS,DIRECT_Y_PLUS},
		{DIRECT_Z_MINUS,DIRECT_Z_PLUS,DIRECT_X_PLUS,DIRECT_X_MINUS,DIRECT_Y_MINUS,DIRECT_Y_PLUS},
	};
	//ĂΕ炻̑΁uIvꍇ̊e̕ω
	final int direction_ways_axis[/*direct*/][/*΁uIv*/][/*axis*/]={
		{{1,0,0},{0,-1,0},{0,0,1}},
		{{-1,0,0},{0,-1,0},{0,0,-1}},
		{{0,0,1},{0,-1,0},{-1,0,0}},
		{{0,0,-1},{0,-1,0},{1,0,0}},
	};
	//------------------------------ϐ
	//Hf[^
	int dist_x,dist_y,dist_z;
	boolean maze_data[][][];
	//̈ʒu
	int start_x,start_y,start_z;
	//݈ʒu
	int pos_x,pos_y,pos_z;
	//݂̕
	int direction;
	//H쐬p
	int cont_limit;
	int route_limit;
	//-----------------------------------
	//RXgN^
	public M04Maze(int dist_x,int dist_y,int dist_z){
		//H쐬p
		cont_limit=6;
		route_limit=50;
		//H̑傫Zbg
		this.dist_x=dist_x;
		this.dist_y=dist_y;
		this.dist_z=dist_z;
		//̈ʒu
		start_x=(int)(dist_x/2);
		start_y=0;
		start_z=(int)(dist_z/2);
		//݈ʒuilj
		pos_x=start_x;
		pos_y=start_y;
		pos_z=start_z;
		//݂̕ilj
		direction=DIRECT_Z_MINUS;
		//H
		formatMaze();
		//H쐬
		makeMaze();
	}
	//------------------------------
	//H
	private void formatMaze(){
		//
		maze_data=new boolean[dist_x][dist_y][dist_z];
		for(int x=0;x<dist_x;x++){
			for(int y=0;y<dist_y;y++){
				for(int z=0;z<dist_z;z++){
					maze_data[x][y][z]=false;	//Sĕ
				}
			}
		}
	}
	//----------------------------------
	//H쐬
	private void makeMaze(){
		//
		for(int i=0;i<10;i++){
			makeRoute();	//ʘH쐬
		}
	}
	//----------------------------------
	//ʘH쐬
	private void makeRoute(){
		//
		int ox,oy,oz;
		int px,py,pz;
		//Jnʒǔ
		if(maze_data[pos_x][pos_y][pos_z]){		//Qڈȍ~
			do{		//ʘHɂȂ܂ŁiA邽߁j
				px=rnd(0,dist_x);
				py=rnd(0,dist_y);
				pz=rnd(0,dist_z);
			}while(!maze_data[px][py][pz]);
		}else{									//P
			//݈ʒuiljɕ쐬
			for(int x=-1;x<=1;x++){
				for(int z=-1;z<=1;z++){
					maze_data[pos_x+x][pos_y][pos_z+z]=true;	//
				}
			}
			//Jnʒu
			px=pos_x;
			py=pos_y;
			pz=pos_z-1;	//݈ʒuiljőɌJɂ悤
		}
		//l
		int cont=0;
		int direct=DIRECT_X_PLUS;
		//ʘH΂
		for(int i=0;i<route_limit;i++){
			//K萔i񂾁ÁAQOsȂĐݒ
			if(cont==0 || checkRoute(px,py,pz,direct)){
				cont=rnd(3,cont_limit+1);
				direct=rnd(DIRECT_X_PLUS,DIRECT_LIMIT);
			}
			//Öʒui[
			ox=px;
			oy=py;
			oz=pz;
			//Vʒuֈړ
			px+=direct_axis[direct][AXIS_X];
			py+=direct_axis[direct][AXIS_Y];
			pz+=direct_axis[direct][AXIS_Z];
			//͈͊Õ`FbN
			if(checkRange(px,py,pz)){
				//Öʒuɖ߂
				px=ox;
				py=oy;
				pz=oz;
				//Đݒ
				cont=rnd(3,cont_limit+1);
				do{		//͈͓ɂȂ܂
					direct=rnd(DIRECT_X_PLUS,DIRECT_LIMIT);
				}while( checkRange(px+direct_axis[direct][AXIS_X],py+direct_axis[direct][AXIS_Y],pz+direct_axis[direct][AXIS_Z]) );
			}
			//ʘHɂ
			maze_data[px][py][pz]=true;
			if(cont>=0){
				cont--;
			}
		}
	}
	//-----------------------------
	//͈͊Õ`FbN
	private boolean checkRange(int px,int py,int pz){
		if(px<0 || px>=dist_x || py<0 || py>=dist_y || pz<0 || pz>=dist_z){
			return true;
		}
		return false;
	}
	//------------------------------
	//wʒuwQO̒ʘH`FbNiʘH쐬j
	private boolean checkRoute(int px,int py,int pz,int direct){
		int qx=px+direct_axis[direct][AXIS_X]*2;
		int qy=py+direct_axis[direct][AXIS_Y]*2;
		int qz=pz+direct_axis[direct][AXIS_Z]*2;
		//͈͊O
		if(checkRange(qx,qy,qz)){
			return true;
		}
		//ʘH
		if(maze_data[qx][qy][qz]){
			return true;
		}
		//
		return false;
	}
	//----------------------------------
	//݈ʒuwPO̒ʘH`FbNiړj
	private boolean checkRoute(int direct){
		int qx=pos_x+direct_axis[direct][AXIS_X];
		int qy=pos_y+direct_axis[direct][AXIS_Y];
		int qz=pos_z+direct_axis[direct][AXIS_Z];
		//͈͊O
		if(checkRange(qx,qy,qz)){
			return false;
		}
		//ǂ
		if(!maze_data[qx][qy][qz]){
			return false;
		}
		//
		return true;
	}
	//---------------------------
	//
	private int rnd(int min,int max){
		return (int)((max-min)*Math.random()+min);
	}
	//------------------------
	//Hړ
	public void move(int way){
		int direct=direction_way[direction][way];
		//͈͊Õ`FbN
		if(checkRoute(direct)){
			//
			pos_x+=direct_axis[direct][AXIS_X];
			pos_y+=direct_axis[direct][AXIS_Y];
			pos_z+=direct_axis[direct][AXIS_Z];
		}
	}
	//------------------------
	//H]
	public void turn(int way){
		if(way!=DIRECT_Y_PLUS && way!=DIRECT_Y_PLUS){
			direction=direction_way[direction][way];
		}
	}
	//--------------------------
	//`pɕǂ̗L𔻒
	public boolean checkBlock(int block_pos[]){
		//
		int qx=pos_x;
		int qy=pos_y;
		int qz=pos_z;
		for(int i=0;i<3;i++){
			qx+=direction_ways_axis[direction][i][AXIS_X]*block_pos[i];
			qy+=direction_ways_axis[direction][i][AXIS_Y]*block_pos[i];
			qz+=direction_ways_axis[direction][i][AXIS_Z]*block_pos[i];
		}
		//͈͊O
		if(checkRange(qx,qy,qz)){
			return true;
		}
		//ǂ
		if(!maze_data[qx][qy][qz]){
			return true;
		}
		//
		return false;
	}
}
